C----------------------------------------------------------------------
c     Programme L3DAXI04.for

C
C       PROGRAM 23
C
C
C       THIS PROGRAM SOLVES AXI SYMMETRICAL (PO) TENTIAL PROBLEMS
C       WITH One DOMAIN USING (CON)STANT (B)OUNDARY (E)LEMENTS
C
C
$include : 'L3DAXI04.inc'

	CHARACTER*64 FILEIN,FILEOUT  
C
	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)
	COMMON/MATG/   G(NMX,NMX)
C	DIMENSION Iperm(NMX)
C
C       ASSIGN NUMBERS FOR INPUT AND OUTPUT FILES
C
	INP=5
	IPR=6

      WRITE(*,'('' L3DAXI04'')')
C
C	READ NAMES AND OPEN FILES FOR INPUT AND OUTPUT
C

      CALL GETFNAMES(FILEIN, FILEOUT)
	OPEN(5,FILE=FILEIN,STATUS='OLD')
	OPEN(6,FILE=FILEOUT,STATUS='UNKNOWN')
C
C       READ DATA
C
      CALL INPUMPC
C
C       COMPUTE THE GEOMETRICAL QUANTITIES OF INTEREST
C
      CALL GEOM
C
C       COMPUTE H AND G MATRICES AND FORM SYSTEM ( A X = F )
C
      write(*,'('' Now Calculating G and H'')')
      CALL GHMAMPC
C
C       SOLVE SYSTEM OF EQUATIONS
C
      write(*,'('' Now Solving'')')
      CALL DPVT(G,DFI,N,1,NMX,1.d-5,ier)
C      CALL DPVTOT(G,DFI,N,1,NMX,Iperm,1.d-5,ier)
      if(ier.ne.0)write(6,'('' **** IER NON ZERO IN DPVT :'',i4)')ier
C
C       COMPUTE POTENTIAL VALUES AT INTERNAL POINTS
C
      CALL REORDER
C
C       PRINT RESULTS AT BOUNDARY NODES AND INTERNAL POINTS
C
      CALL OUTPMPC
C
C       Calcul et impression des flux
C
      call outflux
      call current
C
C       CLOSE INPUT AND OUTPUT FILES
C
      CLOSE(INP)
      CLOSE(IPR)
      STOP
      END
$page
C----------------------------------------------------------------------
	SUBROUTINE INPUMPC
C
C       PROGRAM 24
C

$include :  'L3DAXI04.inc'

	CHARACTER*80 TITLE
C
	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX),CY(NMX),SOL(NMX)
C
C       N=NUMBER OF ELEMENTS (= NUMBER OF BOUNDARY NODES - M )
C       L=NUMBER OF INTERNAL POINTS WHERE THE FUNCTION IS CALCULATED.
C       M=NUMBER OF BOUNDARIES
C
C
	WRITE(6,100)
100     FORMAT(' ',79('*'))
C
C       READ JOB TITLE
C
	READ(5,'(A)') TITLE
	WRITE(6,'(A)') TITLE
C
C       READ NUMBER OF BOUNDARY ELEMENTS AND INTERNAL POINTS
C
	READ(5,*) NSX,N,L,M,(NC(K),K=1,M)

	IF(N.GT.NMX)THEN
	WRITE(*,'('' TOO MANY ELEMENTS :'',I4,''/'',I4,'' (maximum)'')')
     &      N, NMX
      STOP '*** FATAL ERROR ***'  
      ENDIF

	IF(M.GT.MMX)THEN
	WRITE(*,'('' TOO MANY BOUNDARIES :'',I4,''/'',I4,'' (maximum)'')')
     &      M, MMX
      STOP '*** FATAL ERROR ***'  
      ENDIF
	  
	WRITE(6,300) N,L
300     FORMAT(//' DATA'//2X,'NUMBER OF BOUNDARY ELEMENTS =',I4/,2X,
     *  'NUMBER OF INTERNAL POINTS WHERE THE FUNCTION IS CALCULATED =',
     *  I4)
C
	WRITE(6,350) NSX
350	FORMAT(//2X,'X-SYMMETRY=',I2)
C
	IF(M)40,40,30
30      WRITE(6,999)M,(NC(K),K=1,M)
999     FORMAT(/2X,'NUMBER OF DIFFERENT BOUNDARIES =',I3/2X,
     *  'LAST NODE OF EACH BOUNDARY =',5(I4,','))
C
C
C       READ COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY ELEMENTS
C       IN ARRAYS X AND Y
C
40    WRITE(6,500)
500   FORMAT(//2X,'COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY',
     *  ' ELEMENTS',//1X,'POINT',7X,'X',15X,'Y')
	READ(5,*) (X1(I),Y1(I),I=1,N + M)
	DO 10 I=1,N + M
10    WRITE(6,700) I,X1(I),Y1(I)
700   FORMAT(1X,I4,2(2X,1pE14.5))
C
C       READ BOUNDARY CONDITIONS IN F(I) VERTOR, IF KODE(I)=0 THE FI(I)
C       VALUE IS A KNOWN POTENTIAL;IF KODE(I)=1 THE FI(I) VALUE IS A
C       KNOWN POTENTIAL DERIVATIVE (FLUX).
C
	WRITE(6,800)
800   FORMAT(//2X,'BOUNDARY CONDITIONS'//2X,'NODE',7X,'CODE',8X,
     *'PRESCRIBED VALUE')

	DO 20 I=1,N
	READ(5,*) KODE(I)
	BACKSPACE(5)
	IF(KODE(I).LE.0.OR.KODE(I).EQ.1)THEN
	ZS(I) = 0.
	READ(5,*) KODE(I),FI(I)
	WRITE(6,950)I,KODE(I),FI(I)
	ELSEIF(KODE(I).EQ.2)THEN
	READ(5,*) KODE(I),FI(I),ZS(I)
	WRITE(6,950)I,KODE(I),FI(I),ZS(I)
	ELSE
	WRITE(6,'('' UNKNOWN CODE AT I='',i3,'' KODE ='',i3/)')I,KODE(I)
	STOP'*** JOB ABORTED ***'
	ENDIF
950	FORMAT(1X,I4,8X,I2,8X,1pE14.5,8X,E14.5)
20	CONTINUE
C
C       READ COORDINATES OF INTERNAL POINTS
C
	IF(L.EQ.0) GOTO 50
	READ(INP,*) (CX(I),CY(I),I=1,L)
50     CONTINUE
	END
$page
C----------------------------------------------------------------------
	SUBROUTINE GEOM
C
C       CALCULATE THE GEOMETRICAL ELEMENTS OF THE BOUNDARIES
C
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)
C
C       
C
	IB = 1
      J1 = 1
      J2 = 1
	DO 100 IB = 1 , M
C     
C     Beginning and ending indexes to boundary IB
C
      IF (IB.EQ.1) then
      I1 = 1
      I2 = NC(1)
      else
      I1 = NC(IB-1)+1
      I2 = NC(IB)
      endif
c      
      DO 102 I = I1 ,I2-1
      X2(J2) = X1(I+1)
      Y2(J2) = Y1(I+1)
      J2 = J2 + 1 
102   continue
      
      DO 103 I = I1, I2-1
      X1(J1) = X1(I)
      Y1(J1) = Y1(I)
      J1 = J1 + 1
103   continue
C
100   continue

C
      DO 101 J1 = 1, N
C
C       MID POINT, SLOPE, LENGHT
C
	XM( J1 ) = .5d0 * ( X1(J1) + X2(J1) )
	YM( J1 ) = .5d0 * ( Y1(J1) + Y2(J1) )
C
	DX = X2(J1) - X1(J1)
	DY = Y2(J1) - Y1(J1) 
C
	S( J1 )  = DSQRT ( DX * DX + DY * DY )
C
	TX ( J1 ) =  DX / S ( J1 )
	TY ( J1 ) =  DY / S ( J1 ) 
C
C       NEXT POINT
C       
101     CONTINUE
	END     
C----------------------------------------------------------------------
      SUBROUTINE GHMAMPC
C
C       PROGRAM 25
C
C       THIS SUBROUTINE COMPUTES THE H AND G MATRICES
C       AND FORMS THE SYSTEM OF EQATIONS A X = F
C
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)
	COMMON/MATG/   G(NMX,NMX)
C
C     EXAMINES SYMMETRIES
C
      IF(NSX.EQ.0)THEN
      ISX = 1                   
      ELSE
      ISX = -1
      ENDIF
C
C       COMPUTE THE COEFFICIENTS OF G AND H MATRICES
C
      DO 200 I = 1 , N 
C      
      DFI(I) = 0.d0
C
      DO 100 J = 1 , N
C
      G1 =   0.D0
      IF(I.EQ.J) THEN
      H1 =  -.5D0
      ELSE
      H1 = 0.D0
      ENDIF

      DO IX = ISX, 1, 2
      KX = 1
      IF( IX .EQ. -1) KX = NSX

	  IF (J.EQ.I.AND.IX.EQ.1) THEN

      call SING3 ( XM(i), YM(i), S(i), TX(i), TY(i),
     &                                  G2, H2 )
      
      ELSE

      call NORM ( IX*XM(i), YM(i), YM(j), XM(j), S(j), TX(j), TY(j), 
     &                                  G2, H2)
C
      ENDIF

      G1 = G1 +  KX  * G2
      H1 = H1 +  KX  * H2   

      ENDDO

C
C       REORDER THE COLUMNS OF THE SYSTEM IN ACCORDANCE
C       WITH THE BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX A WHICH
C       IS STORED IN G
C
	IF ( KODE(J). EQ . 1 ) THEN 
C
	H      = - G1
	G(I,J) = - H1
C
	ELSEIF (KODE(J).EQ.2) THEN
C
	H      = H1 
	G(I,J) = G1 + ZS(J) * H1
C	
	ELSEIF (KODE(J).LE.0) THEN
C
	H      = H1 
	G(I,J) = G1
C
	ENDIF
C
C	FORM THE RIGHT HAND SIDE VECTOR F WHICH IS STORED IN DFI
C
	DFI(I) = DFI(I) + H * FI(J)
C
C       NEXT POINT
C       
100     CONTINUE  
C
C       NEXT LINE
C
200     CONTINUE
	END
$page
C----------------------------------------------------------------------
	SUBROUTINE REORDER
C
C       PROGRAM 26
C
C
C       THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)
C
C       REARRANGE THE FI AND DFI ARRAYS TO STORE ALL THE VALUES OF THE
C       POTENTIAL IN FI AND ALL THE VALUES OF THE DERIVATIVE IN DFI
C
	DO 20 I=1,N
	IF(KODE(I).EQ.1) Then
      CH=FI(I)
	FI(I)=DFI(I)
	DFI(I)=CH
	ELSEIF(KODE(I).EQ.2) THEN
	FI(I) = FI(I) - ZS(I) * DFI(I)
	ENDIF
20    CONTINUE
	END
$page
C----------------------------------------------------------------------
	SUBROUTINE POTENT(X,Y,F)
C
C
C
C       THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)
C
C     EXAMINES SYMMETRIES
C
      IF(NSX.EQ.0)THEN
      ISX = 1
      ELSE
      ISX = -1
      ENDIF
C
C       COMPUTE THE VALUES OF POTENTIAL AT INTERNAL POINTS
C
C
	F = 0.d0

	DO 100 J = 1 , N
C
      G1 = 0.d0
	H1 = 0.d0
C
      DO IX = ISX, 1, 2
      KX = 1
      IF( IX .EQ. -1) KX = NSX

      call NORM ( IX*X, Y, YM(j), XM(j), S(j), TX(j), TY(j),
     &                                  G2, H2 )

      G1 = G1 +  KX * G2
      H1 = H1 +  KX * H2
	ENDDO   

      F = F + H1 * FI(J) - G1 * DFI(J)
100   continue
c
	END
C----------------------------------------------------------------------
	SUBROUTINE GRADIENT(X,Y,F,FX,FY)
C
C	PROGRAM 26
C
C
C	THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL GRADIENT 
C	AT INTERNAL POINTS
C
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX),CY(NMX),SIG(NMX)
C
C	COMPUTE THE VALUES OF POTENTIAL GRADIENT AT INTERNAL POINTS
C
      data eps/ .0001d0 /
C      
      call POTENT(X,Y,F)
      call POTENT(X+eps,Y,FX)
      FX = (FX - F)/eps
      call POTENT(X,Y+eps,FY)
      FY = (FY - F)/eps
      end
$page
C----------------------------------------------------------------------
	SUBROUTINE OUTPMPC
C
C	PROGRAM 27
C
C	THIS SUBROUTINE PRINTS THE VALUES OF THE POTENTIAL AND ITS NORMAL
C	DERIVATIVE AT BOUNDARY NODES. IT ALSO PRINTS THE VALUES OF THE
C	POTENTIAL AT INTERNAL POINTS
C
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SIG(NMX)

c      open(10,file='out1')
c      open(11,file='out2')
	WRITE(6,100)
100	FORMAT(' ',79('*')//1X,'RESULTS'//2X,'BOUNDARY NODES'//' NODE',
     &10X,'Z',15X,'R',13X,'S',
     &13X,'POTENTIAL',3X,'POTENTIAL DERIVATIVE'/)
	CURV = S(1)/2.d0
	DO 10 I=1,N
	IF(KODE(I).EQ.3)THEN
	WRITE(6,200) I,XM(I),YM(I),CURV,FI(I)
	ELSE
	WRITE(6,200) I,XM(I),YM(I),CURV,FI(I),DFI(I)
	ENDIF
	CURV = CURV + .5d0*(S(I)+S(I+1)) 
10	CONTINUE
200	FORMAT(I5,5(2X,1Pe14.5))
C
	IF(L.EQ.0) GOTO 30
	WRITE(6,300)
300	FORMAT(//,2X,'INTERNAL POINTS',//8X,'Z',15X,'R',13X,
     *	'POTENTIAL',5X,'Z-DERIVATIVE',4X,'R-DERIVATIVE'/)
	DO 20 K=1,L
	CALL GRADIENT (CX(K),CY(K),F,FX,FY)
c      write(11,*)F
20	WRITE(6,400) CX(K),CY(K),F,FX,FY

400	FORMAT(5(2X,1pE14.6))
30	WRITE(6,500)
500	FORMAT(' ',79('*'))

	RETURN
	END
  

$page
C----------------------------------------------------------------------
	subroutine  outflux
c
c       Calcul des flux sur les portions a Potentiel impose Kode=0
c
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)

	deuxpi = 8.d0*Datan(1.d0)
c
	WRITE(6,'(/'' FLUX''//)')
c
	init=0
	i=1
100     if(i.gt.N) goto 200
c
	if(kode(i).eq.1)then    

	if(init.eq.0) then
	i=i+1
	goto 100
	endif

c	if(init.eq.1) then
	if(init.ne.0) then
	i2=i-1
c
	WRITE(6,'('' FLUX :'',I4,''-'',I4,'' :'',1Pe15.8)')
     1          i1,i2,flux
	init=0
	i=i+1
	goto 100
	endif
c
	else
	if(init.eq.0)then
	init=1
	I1=i
	flux=S(i)*dfi(i)*deuxpi*YM(i)
	else
	flux=flux+S(i)*dfi(i)*deuxpi*YM(i)
	endif
c
	i=i+1
	goto 100
c
	endif
c
200   continue
      if (init.eq.1) then
      WRITE(6,'('' FLUX :'',I3,''-'',I3,'' :'',1Pe15.8)')
     &               i1,N,flux
      endif
      WRITE(6,500)
500   FORMAT(' ',79('*'))
	end
$page
	subroutine  current
c
c       Calcul des flux sur les portions a Potentiel impose Kode=0
c
$include :  'L3DAXI04.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX)
	COMMON/GEOXTR/ CX(NMX)  ,CY(NMX) ,SOL(NMX)
	deuxpi = 8.d0*datan(1.d0)
c
c
c     
      do 101 i=1,NMX
101   SOL(i) = 0
c
      JMAX = 0
c
      DO 100 i=1,N

      if(kode(i).lt.0)then    
      j = -Kode(i)
      Sol(j) = Sol(j) + S(i)*dfi(i)*deuxpi*YM(i)
      jmax = max0(jmax,j)
      endif
      
100   continue
      if(jmax.ne.0) then
      WRITE(6,'(/'' CURRENTS''/)')
      do 200 j=1, jmax
      WRITE(6,'('' FLUX'',I3,'' :'',1Pe15.8)')j,sol(j)
      WRITE(*,'('' FLUX'',I3,'' :'',1Pe13.5)')j,sol(j)
200   continue
      WRITE(6,500)
500   FORMAT(' ',79('*'))
      endif
	end
$page
	real*8 function EM1( x )
c
c
c       Integrale elliptique complete de 2 espece
c
c
	Implicit real*8(a-h,o-z)
	real*8 LE
c
	data A0/1.d0/
	data A1/.44325141463d0/
	data A2/.06260601220d0/
	data A3/.04757383546d0/
	data A4/.01736506451d0/
c
	data B1/.24998368310d0/
	data B2/.09200180037d0/
	data B3/.04069697526d0/
	data B4/.00526449639d0/
c
c       
	PE = ((( A4*x + A3 )*x + A2 )*x + A1 )*x + A0
	LE = ((( B4*x + B3 )*x + B2 )*x + B1 )*x 
c
	EM1 = PE + dlog( 1.d0/x ) * LE
c
	end
$page
	real*8 function aKM1( x )
c
c
c       Integrale elliptique complete de 1 espece
c
c
	Implicit real*8(a-h,o-z)
	real*8 LK
c
	data A0/1.38629436112d0/
	data A1/ .09666344259d0/
	data A2/ .03590092383d0/
	data A3/ .03742563713d0/
	data A4/ .01451196212d0/
c
	data B0/.5d0/
	data B1/.12498593597d0/
	data B2/.06880248576d0/
	data B3/.03328355346d0/
	data B4/.00441787012d0/
c
c       
	PK = ((( A4*x + A3 )*x + A2 )*x + A1 )*x + A0
	LK = ((( B4*x + B3 )*x + B2 )*x + B1 )*x + B0
c
	aKM1 = PK + dlog( 1./x ) * LK
c
	end
$page
	subroutine NOYAUX ( x , y , a , b , G , GX , GY )
c
c
c       Calcul des noyaux des integrales (premier et second)
c
c
c
	Implicit real*8(a-h,o-z)
	real*8 K , E
c	data unsm4pi / -7.957747E-02 /
	data init /0/
c
c       Calcul des integrales elliptiques
c
	if(init.eq.0) then
	init = 1
	Pi = 4.d0*datan(1.d0)
	unsm4pi = -1.d0/4.d0/Pi
	endif

      XMB   = x - b
      XMB2  = XMB * XMB  
      Y2    = y * y
      A2    = a * a
      YPA2  = (y + a) * (y + a)
      YMA2  = (y - a) * (y - a)
      RPM12 = dsqrt ( XMB2 + YPA2 )
      RXY2  = XMB2 + YMA2
      R12 = XMB2 + Y2 - A2 
      xm1 = RXY2 / ( XMB2 + YPA2 )
c
      E =  EM1(xm1)
      K = aKM1(xm1)   
c
c
c       Premier noyau
c
c
      G = 4 * a * K / RPM12  
c
c
c       Deuxime noyau 
c
c
      GX   = 4. * a * XMB * E / RPM12 / RXY2
c    
      GY = 2./ RPM12 * ( R12/RXY2 * E - K)       
c        
c       Normalisation              
c
	G  = G  * unsm4pi
	GX = GX * unsm4pi
	GY = GY * unsm4pi
c        
	end
$page
	subroutine NORM ( x , y , a0 , b0 , ds , cosa , sina ,
     &                                G , H )
c
c
c       Calcul des contributions regulieres
c       integration de gauss en 16 points
c
c
	Implicit real*8(a-h,o-z)

	dimension w(8,4),p(8,4),Ngauss(4)
	data Ngauss/8,4,2,1/
	data p/
	*.095012509838d0,.281603550779d0,.458016777657d0,.617876244403d0,
     *.755404408355d0,.865631202388d0,.944575023073d0,.989400934992d0,
     *.183434642496d0,.525532409916d0,.796666477414d0,.960289856498d0,
     *                              4 * 0.d0 ,
     *.339981043585d0,.861136311594d0,      6 * 0.d0 ,   
     *.577350269190d0,               7 * 0.d0     /
	data w/
	*.189450610455d0,.182603415045d0,.169156519395d0,.149595988817d0,
     *.124628971256d0,.095158511632d0,.062253523939d0,.027152459412d0,
     *.362683783378d0,.313706645878d0,.222381034453d0,.101228536290d0,
     *                              4 * 0.d0 ,
     *.652145154863d0,.347854845137d0,      6 * 0.d0 ,
     *        1.0d0 ,                   7 * 0.d0     /     
c
	d = ds  * .5d0
c
	G  = 0.
	GX = 0.
	GY = 0.
c
c
c
	igauss = 1
	do 1 i=1,NGauss(igauss)
c
	pi = p(i,igauss)
	wi = w(i,igauss) * d
c
	s1 =  pi * d
	s2 = -pi * d
c
	a1 = a0 + s1 * sinA
	b1 = b0 + s1 * cosA
c
	a2 = a0 + s2 * sinA
	b2 = b0 + s2 * cosA
c
	call NOYAUX( x , y , a1 , b1 , G1 , GX1 , GY1 )
	call NOYAUX( x , y , a2 , b2 , G2 , GX2 , GY2 )
c
	G   =  G  + wi * ( G1  + G2 )
	GX  = GX  + wi * ( GX1  + GX2 )
	GY  = GY  + wi * ( GY1  + GY2 )      
c
1       continue
c
      H = GX * sina - GY * cosa
c
      end 
$page
	subroutine SING ( y , ds , cosa , sina , G , H )
c
c
c       Calcul des contributions singulieres
c
c
	implicit REAL*8 (A-Z)
	integer init
c	data unsm4pi /-7.957747E-02 /
	
	data init /0/

	if(init.eq.0) then
	init = 1
	Pi = 4.d0*datan(1.d0)
	unsm4pi = -1.d0/4.d0/Pi
	endif
c
	d     = ds/2.d0
	v     = d/y
	LNUS8 = dlog ( v/8.d0 )
	s     = sina
c
	G  =  2.d0 * y    * unsm4pi * ( PG  ( s,v ) + LNUS8 * QG  ( s,v ))
	GX = -2.d0 * cosa * unsm4pi * ( PGX ( s,v ) + LNUS8 * QGX ( s,v ))
	GY =                unsm4pi * ( PGY ( s,v ) + LNUS8 * QGY ( s,v ))
c
        H  = GX * sina - GY * cosa
c      
      end

$page
	subroutine SING3 ( x , y , ds , cosa , sina , G , H )
c
c
c       Calcul de la contribution singuliere en 3 parties
c
c
	Implicit real*8(a-h,o-z)

	data eps/.1d0/
c
	a0 = y
	b0 = x
	u = ds/2.d0/Y
	if( u . le. eps ) then
c
	
	call SING ( y , ds , cosa , sina , G , H )
c     
	else
c
	dsi = 2.d0 * eps * y
	call SING ( y , dsi , cosa , sina , G , H )
c
	dse = .5d0 * ( ds - dsi )
	s = dsi / 2.d0 + dse / 2.d0
	a = a0 + s * sina
	b = b0 + s * cosa 
	call NORM ( x , y , a , b , dse , cosa , sina , G1 , H1 )
c        
      G = G + G1
      H = H + H1
c
	s = dsi / 2.d0 + dse / 2.d0
	a = a0 - s * sina
	b = b0 - s * cosa 
	call NORM ( x , y , a , b , dse , cosa , sina , G1 , H1 )
c
      G  = G + G1
      H = H + H1
	endif
c
	end
c

C----------------------------------------------------------------------
      SUBROUTINE GETFNAMES(FILEIN, FILEOUT)
      
	CHARACTER*(*) FILEIN,FILEOUT  

      na = nargs()

      if(na.ge.2) then
      call getarg(1,FILEIN,ncar)
	WRITE(*,'('' NAME OF INPUT FILE : '',a)')FILEIN(1:ncar)
      else
	WRITE(*,'('' NAME OF INPUT FILE : ''\)')
	READ(*,'(A)')FILEIN
      IF(FILEIN.eq.' ') FILEIN = 'L3daxi04.in'            
	endif


      if(na.ge.3) then
      call getarg(2,FILEOUT,ncar)
	WRITE(*,'('' NAME OF OUTPUT FILE : '',a/)')FILEOUT(1:ncar)
      else
	WRITE(*,'('' NAME OF OUTPUT FILE : ''\)')
	READ(*,'(A)')FILEOUT
      IF(FILEOUT.eq.' ') FILEOUT = 'L3Daxi04.out'
	endif

      END      

C----------------------------------------------------------------------
      SUBROUTINE XXXGETFNAMES(FILEIN, FILEOUT)
      
	CHARACTER*(*) FILEIN,FILEOUT  

	WRITE(*,'('' NAME OF INPUT FILE : ''\)')
	READ(*,'(A)')FILEIN
      IF(FILEIN.eq.' ') FILEIN = 'L3daxi04.in'            

	WRITE(*,'('' NAME OF OUTPUT FILE : ''\)')
	READ(*,'(A)')FILEOUT
      IF(FILEOUT.eq.' ') FILEOUT = 'L3Daxi04.out'

      END      
c
	Real*8 Function PG(s,v)
	real*8 s , v
 
 	xxxxxx =  3.776041666667D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 1.236979166667D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 7.331692442602D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 4.754098905187D-04
	PG = xxxxxx
 
	PG = PG * v
 
 	xxxxxx =  5.208333333333D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 2.000000000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 3.398437500000D-03
	PG = PG * v + xxxxxx
 
	PG = PG * v
 
 	xxxxxx = -2.777777777778D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 2.777777777778D-02
	PG = PG * v + xxxxxx
 
	PG = PG * v
 
 	xxxxxx =  2.000000000000D+00
	PG = PG * v + xxxxxx
 
	PG = PG * v
 
	end
	Real*8 Function QG(s,v)
	real*8 s , v
 
 	xxxxxx =  5.859375000000D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 4.882812500000D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 4.708426339286D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 4.359654017857D-04
	QG = xxxxxx
 
	QG = QG * v
 
 	xxxxxx =  1.562500000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 9.375000000000D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 3.515625000000D-03
	QG = QG * v + xxxxxx
 
	QG = QG * v
 
 	xxxxxx =  8.333333333333D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 4.166666666667D-02
	QG = QG * v + xxxxxx
 
	QG = QG * v
 
 	xxxxxx = -2.000000000000D+00
	QG = QG * v + xxxxxx
 
	QG = QG * v
 
	end
	Real*8 Function PGX(s,v)
	real*8 s , v
 
 	xxxxxx =  4.603794642857D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 2.763671875000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 4.284667968750D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 9.528958067602D-03
 	xxxxxx = xxxxxx * s
	PGX = xxxxxx
 
	PGX = PGX * v
 
 	xxxxxx =  1.093750000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 4.427083333333D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 3.269531250000D-02
 	xxxxxx = xxxxxx * s
	PGX = PGX * v + xxxxxx
 
	PGX = PGX * v
 
 	xxxxxx =  4.166666666667D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 9.027777777778D-02
 	xxxxxx = xxxxxx * s
	PGX = PGX * v + xxxxxx
 
	PGX = PGX * v
 
 	xxxxxx =  1.000000000000D+00
 	xxxxxx = xxxxxx * s
	PGX = PGX * v + xxxxxx
 
	PGX = PGX * v
 
	end
	Real*8 Function QGX(s,v)
	real*8 s , v
 
 	xxxxxx =  8.789062500000D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 2.197265625000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 6.539481026786D-03
 	xxxxxx = xxxxxx * s
	QGX = xxxxxx
 
	QGX = QGX * v
 
 	xxxxxx =  1.562500000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 2.109375000000D-02
 	xxxxxx = xxxxxx * s
	QGX = QGX * v + xxxxxx
 
	QGX = QGX * v
 
 	xxxxxx =  4.166666666667D-02
 	xxxxxx = xxxxxx * s
	QGX = QGX * v + xxxxxx
 
	QGX = QGX * v
 
	QGX = QGX * v
 
	QGX = QGX * v
 
	end
	Real*8 Function PGY(s,v)
	real*8 s , v
 
 	xxxxxx = -9.207589285714D-03
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 1.210286458333D-01
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 1.750488281250D-01
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 6.700165417730D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 3.763834635417D-03
	PGY = xxxxxx
 
	PGY = PGY * v
 
 	xxxxxx = -2.187500000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 1.822916666667D-01
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 1.689843750000D-01
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 2.050781250000D-02
	PGY = PGY * v + xxxxxx
 
	PGY = PGY * v
 
 	xxxxxx = -8.333333333333D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 3.194444444444D-01
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 1.250000000000D-01
	PGY = PGY * v + xxxxxx
 
	PGY = PGY * v
 
 	xxxxxx = -2.000000000000D+00
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s
	PGY = PGY * v + xxxxxx
 
	PGY = PGY * v
 
	end
	Real*8 Function QGY(s,v)
	real*8 s , v
 
 	xxxxxx =  4.687500000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 8.789062500000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 4.185267857143D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 3.051757812500D-03
	QGY = xxxxxx
 
	QGY = QGY * v
 
 	xxxxxx =  7.812500000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 9.843750000000D-02
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s + 1.757812500000D-02
	QGY = QGY * v + xxxxxx
 
	QGY = QGY * v
 
 	xxxxxx =  1.666666666667D-01
 	xxxxxx = xxxxxx * s
 	xxxxxx = xxxxxx * s - 1.250000000000D-01
	QGY = QGY * v + xxxxxx
 
	QGY = QGY * v
 
 	xxxxxx =  2.000000000000D+00
	QGY = QGY * v + xxxxxx
 
	QGY = QGY * v
 
	end


